<!doctype html>
<html>

<head>
  <meta name="generator" content="JSDoc 3.6.3">
  <meta charset="utf-8">
  <title>Source: ads/banner/Banner.Video.js</title>
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Karla:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Noto+Serif:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Inconsolata:500" type="text/css">
  <link href="css/baseline.css" rel="stylesheet">
</head>

<body onload="prettyPrint()">
  <nav id="jsdoc-navbar" role="navigation" class="jsdoc-navbar">
    <div id="jsdoc-navbar-container">
      <div id="jsdoc-navbar-content">
        <a href="index.html" class="jsdoc-navbar-package-name">Home</a>
      </div>
    </div>
  </nav>
  <div id="jsdoc-body-container">
    <div id="jsdoc-content">
      <div id="jsdoc-content-container">
        <div id="jsdoc-banner" role="banner">
        </div>
        <div id="jsdoc-main" role="main">
          <header class="page-header">
            <h1>Source: ads/banner/Banner.Video.js</h1>
          </header>
          <article>
            <pre class="prettyprint linenums"><code>import style from &#x27;./style.scss&#x27;
import { h } from &#x27;preact&#x27;
import { Banner } from &#x27;./Banner.js&#x27;
import { Link, Image, Video } from &#x27;components&#x27;

let classNames &#x3D; (require(&#x27;classnames/bind&#x27;)).bind(style)

/**
 * video odtwarzane po wejściu w obszar viewportu;&amp;lt;br&gt;
 * po zakończeniu filmu wyświetlana jest klikalna grafika
 * @example
 * &amp;lt;BannerVideo
 *   width&#x3D;&quot;300px&quot;
 *   height&#x3D;&quot;250px&quot;
 *   url&#x3D;&quot;http://example.com&quot;
 *   img&#x3D;&quot;http://placekitten.com/300/250&quot;
 *   mp4&#x3D;&quot;https://sample-videos.com/video123/mp4/240/big_buck_bunny_240p_10mb.mp4&quot;
 *   autoplay
 *   vast&#x3D;[
 *   {
 *     &#x27;firstQuartile&#x27;: &#x27;http://example.com/firstQuartile.gif&#x27;,
 *     &#x27;midpoint&#x27;: &#x27;http://example.com/midpoint.gif&#x27;,
 *     &#x27;thirdQuartile&#x27;: &#x27;http://example.com/thirdQuartile.gif&#x27;
 *   },
 *   {
 *     &#x27;firstQuartile&#x27;: &#x27;http://another.example.com/firstQuartile.gif&#x27;,
 *     &#x27;midpoint&#x27;: &#x27;http://another.example.com/midpoint.gif&#x27;,
 *     &#x27;thirdQuartile&#x27;: &#x27;http://another.example.com/thirdQuartile.gif&#x27;
 *   }
 *   ]
 *   style&#x3D;{
 *    &#x27;border&#x27;: &#x27;3px dotted red&#x27;
 *   }
 *   onReady&#x3D;function(){}
 *   onViewportEnter&#x3D;function(){}
 *   onViewportLeave&#x3D;function(){}
 * /&gt;
 *
 * @export
 * @class BannerVideo
 * @extends {Banner}
 *
 * @prop {object} props - zestaw właściwości komponentu
 * @prop {string} props.img - adres grafiki wyświetlanej po zakończeniu odtwarzania video
 * @prop {string} props.url - adres, na jaki ma przekierowywać grafika wyświetlana po zakończeniu video
 * @prop {string} props.mp4 - video w formacie mp4
 * @prop {string} [props.webm] - video w formacie webm
 * @prop {string} [props.ogv] - video w formacie ogv
 * @prop {object} [props.style] - obiekt ze stylami inline
 * @prop {string[]} [props.classNames] - dodatkowe klasy dla głównego elementu
 * @prop {string} props.width - szerokość komponentu wraz z jednostką
 * @prop {string} props.height - wysokość komponentu wraz z jednostką
 * @prop {boolean} [props.autoplay&#x3D;true] - czy video ma zostać autoodtworzone po wejściu do viewportu
 * @prop {array|object[]} [props.vast] - zestaw(y) kodów mierzących zdarzenia video według specyfikacji vast
 * @prop {function} [props.onReady] - callback wywoływany, gdy komponent zamontował się poprawnie i wszystkie zasoby zostały załadowane
 * @prop {function} [props.onViewportEnter] - callback wywoływany, gdy komponent pojawił się w obszarze viewportu
 * @prop {function} [props.onViewportLeave] - callback wywoływany, gdy komponent opuścił obszar viewportu
 * @prop {object} state - zestaw stanów komponentu
 * @prop {string} state.lifecycle - string reprezentujący bieżący cykl życia komponentu (initialized, ready)
 * @prop {number} state.preloading - liczba zasobów aktualnie preloadowanych przez komponent
 */
export class BannerVideo extends Banner {
  constructor (props, state) {
    super(props, state)

    /**
      * referencja do komponentu &amp;amp;lt;Video/&amp;amp;gt; umożliwiająca korzystanie z jego wewnętrznych metod
      * @type {Component}
      */
    this.video &#x3D; null

    /**
      * po jakim czasie od wejścia do viewportu uruchomić odtwarzanie video
      * @type {number}
      */
    this.viewability &#x3D; 500

    /**
      * przechowuje timeout rozpoczynający odtwarzanie video po wejściu do viewportu
      */
    this.videoAutoplayTimeout &#x3D; null

    this.cssClasses &#x3D; [...super.cssClasses, &#x27;video&#x27;]

    this.onVideoEnd &#x3D; this.onVideoEnd.bind(this)
    this.replay &#x3D; this.replay.bind(this)
  }

  /**
   * wejście w obszar viewportu;&amp;lt;br&gt;
   * ustawia dodatkowo timeout, po którym video zostaje autoodtworzone, jeśli prop autoplay został ustawiony na true
   */
  onViewportEnter () {
    this.videoAutoplayTimeout &#x3D; setTimeout(() &#x3D;&gt; {
      if (!this.state.autoplay) {
        this.setState({ autoplay: true })
      }
      this.video.play()
      this.videoAutoplayTimeout &#x3D; null
    }, this.viewability)

    super.onViewportEnter()
  }

  /**
   * wyjście z obszaru viewportu;&amp;lt;br&gt;
   * pauzuje odtwarzanie video, jeśli było uruchomione
   */
  onViewportLeave () {
    if (this.videoAutoplayTimeout) {
      clearTimeout(this.videoAutoplayTimeout)
    }
    this.video.pause()
    super.onViewportLeave()
  }

  /**
   * callback wywoływany przez komponent &amp;amp;lt;Video/&amp;amp;gt;, zmiana videoEnded na true ukrywa video i pokazuje w jego miejsce klikalną grafikę
   */
  onVideoEnd () {
    this.setState({ videoEnded: true })
  }

  /**
   * wykorzystywany przez przycisk wyświetlany nad klikalną grafiką
   */
  replay () {
    this.setState({ videoEnded: false })
    this.video.play()
  }

  render () {
    return (
      &amp;lt;div className&#x3D;{this.classNames()} style&#x3D;{this.style}&gt;
        &amp;lt;Video
          ref&#x3D;{video &#x3D;&gt; { this.video &#x3D; video }}
          autoplay&#x3D;{this.props.autoplay}
          playsinline
          gui&#x3D;{[&#x27;mute&#x27;, &#x27;fullscreen&#x27;]}
          mp4&#x3D;{this.props.mp4}
          webm&#x3D;{this.props.webm}
          ogv&#x3D;{this.props.ogv}
          onReady&#x3D;{this.onReady}
          onEnded&#x3D;{this.onVideoEnd}
          vast&#x3D;{this.props.vast}
        /&gt;
        {this.state.videoEnded &amp;amp;&amp;amp; (
          &amp;lt;div className&#x3D;{classNames(&#x27;videoEnded&#x27;)}&gt;
            &amp;lt;Link href&#x3D;{this.props.url}&gt;
              &amp;lt;Image src&#x3D;{this.props.img} /&gt;
            &amp;lt;/Link&gt;
            &amp;lt;button onClick&#x3D;{this.replay}&gt;
              &amp;lt;svg viewBox&#x3D;&quot;0 0 512 512&quot;&gt;
                &amp;lt;path d&#x3D;&quot;M0 436V76c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v151.9L235.5 71.4C256.1 54.3 288 68.6 288 96v131.9L459.5 71.4C480.1 54.3 512 68.6 512 96v320c0 27.4-31.9 41.7-52.5 24.6L288 285.3V416c0 27.4-31.9 41.7-52.5 24.6L64 285.3V436c0 6.6-5.4 12-12 12H12c-6.6 0-12-5.4-12-12z&quot;&gt;
                &amp;lt;/path&gt;
              &amp;lt;/svg&gt;
            &amp;lt;/button&gt;
          &amp;lt;/div&gt;
        )}
      &amp;lt;/div&gt;
    )
  }
}
</code></pre>
          </article>
        </div>
      </div>
      <nav id="jsdoc-toc-nav" role="navigation"></nav>
    </div>
  </div>
  <footer id="jsdoc-footer" class="jsdoc-footer">
    <div id="jsdoc-footer-container">
      <p>
        Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc</a> 3.6.3 on August 23, 2019.
      </p>
    </div>
  </footer>
  <script src="scripts/jquery.min.js"></script>
  <script src="scripts/jquery.cookie.js"></script>
  <script src="scripts/tree.jquery.js"></script>
  <script src="scripts/prettify.js"></script>
  <script src="scripts/jsdoc-toc.js"></script>
  <script src="scripts/linenumber.js"></script>
  <script src="scripts/scrollanchor.js"></script>
</body>

</html>